﻿Imports System.Data.OleDb
Imports System.IO

Public Class frmContatos
    Dim PK As Integer                  '// variavel local
    Dim NovosDados As Boolean = False  '// NovosDados = True (Add), False => modo de edição.
    '//
    Dim novoNomeArquivo As String       '// Novo nome da imagem
    Dim originalNomeImagem As String    '// nome original da imagem
    Dim streamPic As Stream             '// Usando Stream ao invés de IO

    Private Sub frmContactPerson_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Conn = ConectarBancoDados()
        lblRecordCount.Text = ""
        Call NovoModo()
        Call ConfiguraGridDados()
        Call RetornaDados()
    End Sub

    Private Sub frmContactPerson_FormClosed(sender As Object, e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        If Conn.State = ConnectionState.Open Then Conn.Close()
        Conn.Dispose()
        Me.Dispose()
        Application.Exit()
    End Sub

    '// Inicializa DataGridView 
    Private Sub ConfiguraGridDados()
        With dgvDados
            .RowHeadersVisible = False
            .AllowUserToAddRows = False
            .AllowUserToDeleteRows = False
            .AllowUserToResizeRows = False
            .MultiSelect = False
            .SelectionMode = DataGridViewSelectionMode.FullRowSelect
            .ReadOnly = True
            .Font = New Font("Tahoma", 9)
            ' Especifica Colunas
            .Columns.Add("ContactPK", "ID")
            .Columns.Add("Fullname", "Nome")
            .Columns.Add("Nickname", "Apelido")
            .Columns.Add("PositionName", "Cargo")
            .Columns.Add("DepartmentName", "Setor")
            .Columns.Add("Mobile", "Celular")
            .Columns.Add("Phone", "Telefone")
            .Columns.Add("Email", "Email")
            .Columns.Add("LineID", "Line")
            .Columns.Add("FacebookID", "Facebook")
            .Columns.Add("PictureName", "Imagem")
            .Columns.Add("Note", "Notas")
            '// Oculta Colunas
            .Columns(0).Visible = False
            .Columns(7).Visible = False
            .Columns(8).Visible = False
            .Columns(9).Visible = False
            .Columns("PictureName").Visible = False
            .Columns("Note").Visible = False
            ' Coluna Autosize
            .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill
            .AutoResizeColumns()
            '// Cor Even-Odd
            .AlternatingRowsDefaultCellStyle.BackColor = Color.AliceBlue
            ' Ajusta o estilo do Header
            With .ColumnHeadersDefaultCellStyle
                .BackColor = Color.Navy
                .ForeColor = Color.Black ' Color.White
                .Font = New Font("Tahoma", 9, FontStyle.Bold)
            End With
        End With
    End Sub

    ' / Retorna os dados
    ' / blnProcura = True, Exibe o resultado
    ' / blnProcura = false , Exibe tudo
    Private Sub RetornaDados(Optional ByVal blnProcura As Boolean = False)
        strSQL = " SELECT tblContact.ContactPK, tblContact.Fullname, tblContact.Nickname, tblContact.Mobile, " &
                    " tblContact.Phone, tblContact.eMail, tblContact.LineID, tblContact.FacebookID, tblContact.PictureName, tblContact.Note, " &
                    " tblPosition.PositionName, tblDepartment.DepartmentName " &
                    " FROM [tblPosition] INNER JOIN (tblDepartment INNER JOIN tblContact ON " &
                    " tblDepartment.DepartmentPK = tblContact.DepartmentFK) ON tblPosition.PositionPK = tblContact.PositionFK "

        '// blnProcura = True for Serach
        If blnProcura Then
            strSQL = strSQL &
                " WHERE " &
                " [Fullname] " & " Like '%" & txtProcura.Text & "%'" & " OR " &
                " [Nickname] " & " Like '%" & txtProcura.Text & "%'" & " OR " &
                " [PositionName] " & " Like '%" & txtProcura.Text & "%'" & " OR " &
                " [DepartmentName] " & " Like '%" & txtProcura.Text & "%'" & " OR " &
                " [Mobile] " & " Like '%" & txtProcura.Text & "%'" & " OR " &
                " [Phone] " & " Like '%" & txtProcura.Text & "%'" & " OR " &
                " [eMail] " & " Like '%" & txtProcura.Text & "%'" & " OR " &
                " [LineID] " & " Like '%" & txtProcura.Text & "%'" & " OR " &
                " [FaceBookID] " & " Like '%" & txtProcura.Text & "%'" &
                " ORDER BY ContactPK "
        Else
            strSQL = strSQL & " ORDER BY ContactPK "
        End If
        '//
        Try
            Cmd = New OleDbCommand
            If Conn.State = ConnectionState.Closed Then Conn.Open()
            Cmd.Connection = Conn
            Cmd.CommandText = strSQL
            Dim DR As OleDbDataReader = Cmd.ExecuteReader
            Dim i As Long = dgvDados.RowCount
            While DR.Read
                With dgvDados
                    .Rows.Add(i)
                    .Rows(i).Cells(0).Value = DR.Item("ContactPK").ToString
                    .Rows(i).Cells(1).Value = DR.Item("Fullname").ToString
                    .Rows(i).Cells(2).Value = DR.Item("Nickname").ToString
                    .Rows(i).Cells(3).Value = DR.Item("PositionName").ToString
                    .Rows(i).Cells(4).Value = DR.Item("DepartmentName").ToString
                    .Rows(i).Cells(5).Value = DR.Item("Mobile").ToString
                    .Rows(i).Cells(6).Value = DR.Item("Phone").ToString
                    .Rows(i).Cells(7).Value = DR.Item("eMail").ToString
                    .Rows(i).Cells(8).Value = DR.Item("LineID").ToString
                    .Rows(i).Cells(9).Value = DR.Item("FaceBookID").ToString
                    .Rows(i).Cells(10).Value = DR.Item("PictureName").ToString
                    novoNomeArquivo = DR.Item("PictureName").ToString
                    .Rows(i).Cells(11).Value = DR.Item("Note").ToString
                End With
                i += 1
            End While
            lblRecordCount.Text = "[Total : " & dgvDados.RowCount & " registros]"
            DR.Close()

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        '//
        txtProcura.Clear()
    End Sub

    ' / --------------------------------------------------------------------------------
    ' / Clique duplo para editar item
    Private Sub dgvData_DoubleClick(sender As Object, e As System.EventArgs) Handles dgvDados.DoubleClick
        '// Se adicionar/editar informação será avisado
        If btnDeletar.Text = "Cancelar" Then
            Dim Resultado As Byte = MessageBox.Show("Deseja cancelar a ação em curso ?" & vbCrLf &
                                    "Sim, Se você quiser cancelar ou " & vbCrLf &
                                    "Não, se você quer continuar.", "Comfirma seu Emprego",
                                    MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2)
            '// Nenhuma entrada nova
            If Resultado = DialogResult.No Then Exit Sub
        End If
        '//
        Dim iRow As Integer
        '// Read the value of the focus row.
        iRow = dgvDados.CurrentRow.Index
        '// 
        PK = dgvDados.Item(0, iRow).Value  '// Keep Primary Key
        '//
        txtNome.Text = "" & dgvDados.Item(1, iRow).Value
        '// Keep the original value for later comparison.
        txtNome.Tag = txtNome.Text
        '// Using Double quote "" for trap error null value
        txtApelido.Text = "" & dgvDados.Item(2, iRow).Value
        '// carrega detalhes na combo
        Call PreencherCombobox(cboCargo, "tblPosition", "PositionName", "PositionPK")
        cboCargo.Text = "" & dgvDados.Item(3, iRow).Value
        Call PreencherCombobox(cboSetor, "tblDepartment", "DepartmentName", "DepartmentPK")
        cboSetor.Text = "" & dgvDados.Item(4, iRow).Value
        '//
        txtCelular.Text = "" & dgvDados.Item(5, iRow).Value
        txtTelefone.Text = "" & dgvDados.Item(6, iRow).Value
        txtEMail.Text = "" & dgvDados.Item(7, iRow).Value
        txtLineID.Text = "" & dgvDados.Item(8, iRow).Value
        txtFacebookID.Text = "" & dgvDados.Item(9, iRow).Value
        txtNotas.Text = "" & dgvDados.Item(11, iRow).Value
        '// Load Picture
        Call ExibirImagem(dgvDados.Item(10, iRow).Value)
        '// Change to Edit Mode
        NovosDados = False
        EditarModo()
    End Sub

    ' / Load table detail into ComboBox
    Public Sub PreencherCombobox(cmbCtrl As ComboBox, strTable As String, strFieldName As String, Optional ByVal strFieldPK As String = vbNullString)
        Try
            If Conn.State = ConnectionState.Closed Then Conn.Open()
            strStmt = "SELECT * FROM " & strTable & " ORDER BY " & strFieldName
            Cmd = New OleDb.OleDbCommand(strStmt, Conn)
            DR = Cmd.ExecuteReader
            Dim DT As DataTable = New DataTable
            DT.Load(DR)
            '/ Primary Key (ValueMember)
            cmbCtrl.ValueMember = strFieldPK
            '/ Display the name
            cmbCtrl.DisplayMember = strFieldName
            cmbCtrl.DataSource = DT
            DR.Close()
            Conn.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    ' / Add New Mode
    ' / --------------------------------------------------------------------------------
    Private Sub NovoModo()
        '// Clear all TextBox.
        For Each c In GroupBox1.Controls
            If TypeOf c Is TextBox Then
                DirectCast(c, TextBox).Clear()
                DirectCast(c, TextBox).Enabled = False
            End If
        Next
        '// Clear all ComboBox
        For Each cbo In GroupBox1.Controls.OfType(Of ComboBox)()
            cbo.Enabled = False
        Next
        '//
        btnAdicionar.Enabled = True
        btnSalvar.Enabled = False
        btnDeletar.Enabled = True
        btnDeletar.Text = "Delete"
        btnAtualizar.Enabled = True
        '//
        btnProcurar.Enabled = False
        btnDeletarImagem.Enabled = False
        picImagem.Image = Image.FromFile(caminhoImagens & "people.png")
    End Sub

    ' / Edit Data Mode
    Private Sub EditarModo()
        '// Clear all TextBox
        For Each c In GroupBox1.Controls
            If TypeOf c Is TextBox Then
                DirectCast(c, TextBox).Enabled = True
            End If
        Next
        '// Clear all ComboBox
        For Each cbo In GroupBox1.Controls.OfType(Of ComboBox)()
            cbo.Enabled = True
        Next
        btnAdicionar.Enabled = False
        btnSalvar.Enabled = True
        btnDeletar.Enabled = True
        btnDeletar.Text = "Cancelar"
        btnAtualizar.Enabled = False
        '//
        btnProcurar.Enabled = True
        btnDeletarImagem.Enabled = True
    End Sub

    Private Sub btnSave_Click(sender As System.Object, e As System.EventArgs) Handles btnSalvar.Click
        '// Validate Data
        If txtNome.Text = "" Or IsNothing(txtNome.Text) Or txtNome.Text.Length = 0 Then
            MessageBox.Show("Nome não pode ser vazio.", "Aviso",
                            MessageBoxButtons.OK, MessageBoxIcon.Warning)
            txtNome.Focus()
            Exit Sub
        End If
        '// NovosDados = True, It's Add New Mode
        If NovosDados Then
            '// Is there a duplicate of the existing one?
            strSQL =
                " SELECT Count(tblContact.Fullname) AS CountFullname FROM tblContact " &
                " WHERE Fullname = " & "'" & txtNome.Text & "'"
            If NomeDuplicado(strSQL) Then
                MessageBox.Show("Nome duplicado, informe um novo nome.", "Aviso",
                                MessageBoxButtons.OK, MessageBoxIcon.Warning)
                txtNome.Focus()
                Exit Sub
            End If
            '//
            strSQL = "INSERT INTO tblContact(" &
                " ContactPK, Fullname, Nickname, PositionFK, DepartmentFK, Mobile, Phone, Email, LineID, FacebookID, " &
                " PictureName, [Note], " &
                " DateAdded, DateModified) " &
                " VALUES(" &
                "'" & DefineNovaPK() & "'," &
                "'" & txtNome.Text & "'," &
                "'" & txtApelido.Text & "'," &
                "'" & PKComboBox(cboCargo, "tblPosition", "PositionName", "PositionPK") & "'," &
                "'" & PKComboBox(cboSetor, "tblDepartment", "DepartmentName", "DepartmentPK") & "'," &
                "'" & txtCelular.Text & "'," &
                "'" & txtTelefone.Text & "'," &
                "'" & txtEMail.Text & "'," &
                "'" & txtLineID.Text & "'," &
                "'" & txtFacebookID.Text & "'," &
                "'" & ObtemArquivoImagens() & "'," &
                "'" & txtNotas.Text & "'," &
                "'" & Now.ToString("dd/MM/yyyy") & "'," &
                "'" & Now.ToString("dd/MM/yyyy") & "'" &
                ")"
            '// EDIT MODE
        Else
            '// If the new value (Text) with the original value (Tag) is not equal, then the value changed in field "Fullname"
            If txtNome.Text <> txtNome.Tag Then
                strSQL =
                " SELECT Count(tblContact.Fullname) AS CountFullname FROM tblContact " &
                " WHERE Fullname = " & "'" & txtNome.Text & "'"
                If NomeDuplicado(strSQL) Then
                    MessageBox.Show("Nome duplicado, informe um novo nome.", "Aviso",
                                MessageBoxButtons.OK, MessageBoxIcon.Warning)
                    txtNome.Focus()
                    Exit Sub
                End If
            End If
            '// START UPDATE
            strSQL = "UPDATE tblContact SET " &
                " [Fullname]='" & txtNome.Text & "', " &
                " [Nickname]='" & txtApelido.Text & "', " &
                " [PositionFK]=" & PKComboBox(cboCargo, "tblPosition", "PositionName", "PositionPK") & ", " &
                " [DepartmentFK]=" & PKComboBox(cboSetor, "tblDepartment", "DepartmentName", "DepartmentPK") & ", " &
                " [Mobile]='" & txtCelular.Text & "', " &
                " [Phone]='" & txtTelefone.Text & "', " &
                " [Email]='" & txtEMail.Text & "', " &
                " [LineID]='" & txtLineID.Text & "', " &
                " [FaceBookID]='" & txtFacebookID.Text & "', " &
                " [PictureName]='" & ObtemArquivoImagens() & "', " &
                " [Note]='" & txtNotas.Text & "', " &
                " [DateModified]='" & Now.ToString("dd/MM/yyyy") & "'" &
                " WHERE ContactPK = " & PK & ""
        End If
        '// Insert or Update same as operation
        ExecutaSQL(strSQL)
        '//
        cboCargo.SelectedIndex = 0
        cboSetor.SelectedIndex = 0

        '// Clear rows in DataGridView
        dgvDados.Rows.Clear()
        '// Refresh DataGridView
        Call RetornaDados()
        '// Add New Mode
        Call NovoModo()
    End Sub

    ' / --------------------------------------------------------------------------------
    '// UPDATE DATA
    Private Sub ExecutaSQL(ByVal Sql As String)
        Cmd = New OleDb.OleDbCommand
        If Conn.State = ConnectionState.Closed Then Conn.Open()
        'MsgBox(Sql)
        Try
            Cmd.Connection = Conn
            Cmd.CommandType = CommandType.Text
            Cmd.CommandText = Sql
            Cmd.ExecuteNonQuery()
            MessageBox.Show("Registros Atualizados com Sucesso.", "Atualização", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Cmd.Dispose()
        Catch ex As Exception
            MsgBox("Error Update: " & ex.Message)
        End Try
    End Sub

    ' / Get Filename + Extesnsion only, not Path
    Private Function ObtemArquivoImagens() As String
        '// Get the Filename + Extension only
        Dim iArr() As String
        iArr = Split(novoNomeArquivo, "\")
        ObtemArquivoImagens = iArr(UBound(iArr))
        '//
        '// If same original and new
        If originalNomeImagem = novoNomeArquivo Then Return ObtemArquivoImagens
        '// Remove original picture
        If originalNomeImagem IsNot Nothing Or originalNomeImagem <> "" Then
            If System.IO.File.Exists(originalNomeImagem) = True Then
                System.IO.File.Delete(originalNomeImagem)
            End If
        End If
        '// ------------- Copy File -------------
        ' Determine whether the source file is real or not.
        If System.IO.File.Exists(novoNomeArquivo) = True Then
            ' Trap Error in the case source = destination
            If LCase(caminhoImagens + ObtemArquivoImagens) <> LCase(novoNomeArquivo) Then
                ' Copy the Source file (novoNomeArquivo) to the Destination (DestFile). 
                ' If the same file is found, overwrite (OverWrite = True).
                System.IO.File.Copy(novoNomeArquivo, caminhoImagens + ObtemArquivoImagens, True)
            End If
        End If
    End Function

    ' / --------------------------------------------------------------------------------
    ' / Function to find and create the new Primary Key not to duplicate.
    Function DefineNovaPK() As Long
        strSQL =
            " SELECT MAX(tblContact.ContactPK) AS MaxPK FROM tblContact "
        If Conn.State = ConnectionState.Closed Then Conn.Open()
        Cmd = New OleDb.OleDbCommand(strSQL, Conn)
        '/ Check if the information is available. And return it back
        If IsDBNull(Cmd.ExecuteScalar) Then
            '// Start at 1
            DefineNovaPK = 1
        Else
            DefineNovaPK = Cmd.ExecuteScalar + 1
        End If
    End Function

    ' / --------------------------------------------------------------------------------
    ' / This example uses the Fullname validation.
    Public Function NomeDuplicado(ByVal Sql As String) As Boolean
        If Conn.State = ConnectionState.Closed Then Conn.Open()
        Cmd = New OleDb.OleDbCommand(Sql, Conn)
        ' Return count records
        NomeDuplicado = Cmd.ExecuteScalar
    End Function

    ' / --------------------------------------------------------------------------------
    ' / Function insert new data in Detail Table and return Primary Key for Master Table.
    Function PKComboBox(cmbCtrl As ComboBox, strTable As String, strFieldName As String, Optional ByVal strFieldPK As String = vbNullString) As Integer
        '// If ComboBox is blank data then return 1 (Blank Data)
        If cmbCtrl.Text = "" Or cmbCtrl.Text.Length = 0 Or IsDBNull(cmbCtrl.Text) Then
            'PKComboBox = 1
            Return 1
        End If
        strSQL =
            "SELECT * FROM " & strTable & " WHERE " & strFieldName & " = " & "'" & cmbCtrl.Text & "'"
        If Conn.State = ConnectionState.Closed Then Conn.Open()
        Cmd = New OleDb.OleDbCommand(strSQL, Conn)
        '// Get the Primary Key
        Dim cmbPK As Integer = Cmd.ExecuteScalar
        '// If not have in Detail Table
        If cmbPK <= 0 Then
            strStmt =
                " SELECT MAX(" & strFieldPK & ") AS MaxPK FROM " & strTable
            If Conn.State = ConnectionState.Closed Then Conn.Open()
            Cmd = New OleDb.OleDbCommand(strStmt, Conn)
            '// Increment Primary Key with 1, and Return this value.
            PKComboBox = Cmd.ExecuteScalar + 1
            '/ Add New Data in Detail Table
            Try
                Using Comm As New OleDb.OleDbCommand()
                    With Comm
                        .Connection = Conn
                        .CommandType = CommandType.Text
                        .CommandText =
                            " INSERT INTO " & strTable & " (" & strFieldName & ", " & strFieldPK & ") VALUES (@DName, @DPK)"
                        With .Parameters
                            .Add("@DName", OleDbType.VarChar).Value = cmbCtrl.Text
                            '/ ------------------------------------------------------------------
                            .Add("@DPK", OleDbType.Integer).Value = PKComboBox
                            '/ ------------------------------------------------------------------
                        End With
                        ' Insert new record.
                        .ExecuteNonQuery()
                        .Parameters.Clear()
                        '/ ------------------------------------------------------------------
                    End With
                End Using
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        Else
            PKComboBox = cmbPK
        End If
        Cmd.Dispose()
    End Function

    '/ ------------------------------------------------------------------
    '// Load Detail Table into ComboBox
    Private Sub btnAdd_Click(sender As System.Object, e As System.EventArgs) Handles btnAdicionar.Click
        NovosDados = True  '// Add New Mode
        EditarModo()
        '// Load Detail Table into ComboBox
        Call PreencherCombobox(cboCargo, "tblPosition", "PositionName", "PositionPK")
        Call PreencherCombobox(cboSetor, "tblDepartment", "DepartmentName", "DepartmentPK")
        '//
        txtNome.Focus()
    End Sub

    '// Load Detail Table into ComboBox
    Private Sub btnDelete_Click(sender As System.Object, e As System.EventArgs) Handles btnDeletar.Click
        '// If Edit Data Mode
        If btnDeletar.Text = "Cancelar" Then
            btnAdicionar.Enabled = True
            btnSalvar.Enabled = True
            btnDeletar.Enabled = True
            btnDeletar.Text = "Delete"
            btnAtualizar.Enabled = True
            '//
            btnProcurar.Enabled = False
            btnDeletarImagem.Enabled = False
            '//
            cboCargo.SelectedIndex = -1
            cboSetor.SelectedIndex = -1
            picImagem.Image = Image.FromFile(caminhoImagens & "people.png")
            NovoModo()
        Else
            If dgvDados.RowCount = 0 Then Exit Sub
            '// Receive Primary Key value to confirm the deletion.
            Dim iRow As Long = dgvDados.Item(0, dgvDados.CurrentRow.Index).Value
            Dim FName As String = dgvDados.Item(1, dgvDados.CurrentRow.Index).Value
            Dim Result As Byte = MessageBox.Show("Deseja deletar este registro ?" & vbCrLf & "Nome : " & FName, "Confirma ?", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)
            If Result = DialogResult.Yes Then
                '// iRow is the ContactPK or Primary key that is hidden.
                strStmt = " DELETE FROM tblContact WHERE ContactPK = " & iRow
                '// UPDATE RECORD
                ExecutaSQL(strStmt)
                '// Remove original picture from Column 10 in DataGridView (caminhoImagens from modDataBase.vb)
                Dim strPicName As String = caminhoImagens & dgvDados.Item(10, dgvDados.CurrentRow.Index).Value
                If strPicName IsNot Nothing Then
                    If System.IO.File.Exists(strPicName) = True Then
                        System.IO.File.Delete(strPicName)
                    End If
                End If
                '// Delete Current Row.
                dgvDados.Rows.Remove(dgvDados.CurrentRow)
                '//
                Call NovoModo()
            End If
        End If
    End Sub

    Private Sub btnRefresh_Click(sender As System.Object, e As System.EventArgs) Handles btnAtualizar.Click
        dgvDados.Rows.Clear()
        Call RetornaDados()
    End Sub

    Private Sub txtSearch_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles txtProcura.KeyPress
        '// Undesirable characters for the database ex.  ', * or %
        txtProcura.Text = Replace(Trim(txtProcura.Text), "'", "")
        txtProcura.Text = Replace(Trim(txtProcura.Text), "%", "")
        txtProcura.Text = Replace(Trim(txtProcura.Text), "*", "")
        If Trim(txtProcura.Text) = "" Or Len(Trim(txtProcura.Text)) = 0 Then Exit Sub
        ' RetornaDados(True) It means searching for information.
        If e.KeyChar = Chr(13) Then '// Press Enter
            '// No beep.
            e.Handled = True
            '//
            dgvDados.Rows.Clear()
            Call RetornaDados(True)
        End If
    End Sub

    Private Sub btnBrowse_Click(sender As System.Object, e As System.EventArgs) Handles btnProcurar.Click
        Dim dlgImage As OpenFileDialog = New OpenFileDialog()

        ' / Open File Dialog
        With dlgImage
            .InitialDirectory = caminhoImagens
            .Title = "Selecione Imagens"
            .Filter = "Tipos Imagens (*.jpg;*.png;*.gif;*.bmp)|*.jpg;*.png;*.gif;*.bmp"
            .FilterIndex = 1
            .RestoreDirectory = True
        End With
        ' Select OK after Browse ...
        If dlgImage.ShowDialog() = DialogResult.OK Then
            '// New Image
            novoNomeArquivo = dlgImage.FileName
            picImagem.Image = Image.FromFile(novoNomeArquivo)
        End If
    End Sub

    Private Sub btnDeleteImg_Click(sender As System.Object, e As System.EventArgs) Handles btnDeletarImagem.Click
        If originalNomeImagem = "" Or originalNomeImagem.Length = 0 Then Return
        '//
        picImagem.Image = Image.FromFile(caminhoImagens & "people.png")
        novoNomeArquivo = ""
    End Sub

    ' / -----------------------------------------------------------------------------
    ' / Use Steam instead IO.
    ' / -----------------------------------------------------------------------------
    Sub ExibirImagem(PicName As String)
        Dim imgDB As Image
        ' Get the name of the image file from the database.
        If PicName.ToString <> "" Then
            ' Verify that the image file meets the specified location.
            If System.IO.File.Exists(caminhoImagens & PicName.ToString) Then
                ' Because when deleting the image file is locked, it can not be removed.
                ' The file is closed after the image is loaded, so you can delete the file if you need to
                streamPic = File.OpenRead(caminhoImagens & PicName.ToString)
                imgDB = Image.FromStream(streamPic)
                picImagem.Image = imgDB
                ' Keep the original image file name. If it is recorded, it will be removed.
                originalNomeImagem = caminhoImagens & PicName.ToString
                novoNomeArquivo = originalNomeImagem
            Else
                ' No images were retrieved from the database.
                streamPic = File.OpenRead(caminhoImagens & "people.png")
                imgDB = Image.FromStream(streamPic)
                picImagem.Image = imgDB
                ' Keep image filename blank.
                originalNomeImagem = ""
                novoNomeArquivo = ""
            End If
            ' Is null
        Else
            streamPic = File.OpenRead(caminhoImagens & "people.png")
            imgDB = Image.FromStream(streamPic)
            picImagem.Image = imgDB
            ' Keep image filename blank.
            originalNomeImagem = ""
            novoNomeArquivo = ""

        End If
        '//
        streamPic.Dispose()
        DR.Close()
        Cmd.Dispose()
        Conn.Close()
    End Sub

End Class
